package com.fp.persistence.pgeneral.gene;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import javax.persistence.Query;

import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import java.util.List;

import javax.persistence.Transient;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla
 * TGENESERVICES
 */
@Entity(name = "TgeneServices")
@Table(name = "TGENESERVICES")
public class TgeneServices extends com.fp.dto.AbstractDataTransport implements
		Serializable, HibernateBean, Cloneable {
	/**
	 * HashCode asociado con la Instancia
	 */
	@Transient
	private int hashValue = 0;
	/**
	 * Version de la Clase
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * Clave primaria de la Entidad TgeneServices
	 */
	@Id
	@Column(name = "SERVICECODE", nullable = false, updatable = false)
	private String pk;
	@Column(name = "DESCRIPTION", nullable = true)
	/**
	 * Nombre del servicio
	 */
	private String description;

	@Column(name = "CLASSNAME", nullable = true)
	/**
	 * Clase que se encarga de iniciar o detener el servicio
	 */
	private String classname;

	@Column(name = "AUTOMATIC", nullable = true)
	/**
	 * Y, Indica que el servicio se levanta al moemento de subir el servidor de aplicaciones
	 */
	private String automatic;

	/** Contructor por defecto */
	public TgeneServices() {
	}

	/**
	 * Contructor de TgeneServices
	 * 
	 * @param pPk
	 *            Clave Primaria del entity
	 */
	public TgeneServices(String pPk) {
		this();
		pk = pPk;
	}

	/**
	 * Metodo que entrega datos de la tabla dada la clave primaria.
	 * 
	 * @param pEntityManager
	 *            referencia de la session a obtener datos del bean.
	 * @param pKey
	 *            Caleve primaria del bean.
	 * @return TgeneServices
	 */
	public static TgeneServices find(EntityManager pEntityManager, Object pKey)
			throws Exception {
		TgeneServices obj = pEntityManager.find(TgeneServices.class, pKey);
		return obj;
	}

	/**
	 * Entrega la Clave primaria de TgeneServices
	 * 
	 * @return El objeto que referencia a la Clave primaria de TgeneServices
	 */
	public String getPk() {
		return pk;
	}

	/**
	 * Fija un nuevo valor a la Clave primaria de TgeneServices
	 * 
	 * @param pPk
	 *            El objeto que referencia a la nueva Clave primaria de
	 *            TgeneServices
	 */
	public void setPk(String pPk) {
		pk = pPk;
	}

	/**
	 * Obtiene el valor de description
	 * 
	 * @return valor de description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * Fija el valor de description
	 * 
	 * @param pDescription
	 *            nuevo Valor de description
	 */
	public void setDescription(String pDescription) {
		description = pDescription;
	}

	/**
	 * Obtiene el valor de classname
	 * 
	 * @return valor de classname
	 */
	public String getClassname() {
		return classname;
	}

	/**
	 * Fija el valor de classname
	 * 
	 * @param pClassname
	 *            nuevo Valor de classname
	 */
	public void setClassname(String pClassname) {
		classname = pClassname;
	}

	/**
	 * Obtiene el valor de automatic
	 * 
	 * @return valor de automatic
	 */
	public String getAutomatic() {
		return automatic;
	}

	/**
	 * Fija el valor de automatic
	 * 
	 * @param pAutomatic
	 *            nuevo Valor de automatic
	 */
	public void setAutomatic(String pAutomatic) {
		automatic = pAutomatic;
	}

	public boolean equals(Object rhs) {
		if (rhs == null)
			return false;
		if (!(rhs instanceof TgeneServices))
			return false;
		TgeneServices that = (TgeneServices) rhs;
		if (this.getPk() == null || that.getPk() == null)
			return false;
		return (this.getPk().equals(that.getPk()));
	}

	/**
	 * Implementación del metodo hashCode de la la entidad TgeneServices
	 * 
	 * @return el hashCode la instancia
	 */
	public int hashCode() {
		if (this.hashValue == 0) {
			int result = 17;
			if (this.getPk() == null) {
				result = super.hashCode();
			} else {
				result = this.getPk().hashCode();
			}
			this.hashValue = result;
		}
		return this.hashValue;
	}

	/** Implementación toString */
	public String toString() {
		Field[] fs = this.getClass().getDeclaredFields();
		String data = "";
		for (Field f : fs) {
			try {
				String name = f.getName();
				if (f.getType().getName().compareTo("java.util.Set") == 0)
					continue;
				if (name.compareTo("hashValue") == 0
						|| name.compareTo("serialVersionUID") == 0)
					continue;
				data += name + "=" + f.get(this) + ";";
			} catch (Exception e) {
				continue;
			}
		}
		if (data.compareTo("") == 0) {
			data = super.toString();
		}
		return data;
	}

	/** Implementación de la creación de un bean en blanco TgeneServices */
	public Object createInstance() {
		TgeneServices instance = new TgeneServices();
		return instance;
	}

	/**
	 * Clona la entidad TgeneServices
	 * 
	 * @see com.fp.dto.hb.HibernateBean#cloneMe()
	 */
	public Object cloneMe() throws CloneNotSupportedException {
		TgeneServices p = (TgeneServices) this.clone();
		return p;
	}
	
	//Metodos manuales
	private static String JPQL = " from TgeneServices ";
	
	/**
	 * Metodo que entrega una lista de servicios a subir al servidor de aplicacion. 
	 * @param pEntityManager
	 * @return List<TgeneServices>
	 * @throws Exception
	 */
	@SuppressWarnings("unchecked")
	public static List<TgeneServices> find(EntityManager pEntityManager) throws Exception {
		List<TgeneServices> ldata = null;
		Query qry = pEntityManager.createQuery(JPQL);
		ldata = qry.getResultList();
		return ldata;
	}
	
}
